"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ExternalModule_1 = __importDefault(require("../ExternalModule"));
var Module_1 = __importDefault(require("../Module"));
var entryHashing_1 = require("./entryHashing");
function assignChunkColouringHashes(entryModules, manualChunkModules) {
    var currentEntry, currentEntryHash;
    var modulesVisitedForCurrentEntry;
    var handledEntryPoints = new Set();
    var dynamicImports = [];
    var addCurrentEntryColourToModule = function (module) {
        if (currentEntry.manualChunkAlias) {
            module.manualChunkAlias = currentEntry.manualChunkAlias;
            module.entryPointsHash = currentEntryHash;
        }
        else {
            entryHashing_1.Uint8ArrayXor(module.entryPointsHash, currentEntryHash);
        }
        for (var _i = 0, _a = module.dependencies; _i < _a.length; _i++) {
            var dependency = _a[_i];
            if (dependency instanceof ExternalModule_1.default ||
                modulesVisitedForCurrentEntry.has(dependency.id)) {
                continue;
            }
            modulesVisitedForCurrentEntry.add(dependency.id);
            if (!handledEntryPoints.has(dependency.id) && !dependency.manualChunkAlias) {
                addCurrentEntryColourToModule(dependency);
            }
        }
        for (var _b = 0, _c = module.dynamicImports; _b < _c.length; _b++) {
            var resolution = _c[_b].resolution;
            if (resolution instanceof Module_1.default &&
                resolution.dynamicallyImportedBy.length > 0 &&
                !resolution.manualChunkAlias) {
                dynamicImports.push(resolution);
            }
        }
    };
    if (manualChunkModules) {
        for (var _i = 0, _a = Object.keys(manualChunkModules); _i < _a.length; _i++) {
            var chunkName = _a[_i];
            currentEntryHash = entryHashing_1.randomUint8Array(10);
            for (var _b = 0, _c = manualChunkModules[chunkName]; _b < _c.length; _b++) {
                currentEntry = _c[_b];
                modulesVisitedForCurrentEntry = new Set(currentEntry.id);
                addCurrentEntryColourToModule(currentEntry);
            }
        }
    }
    for (var _d = 0, entryModules_1 = entryModules; _d < entryModules_1.length; _d++) {
        currentEntry = entryModules_1[_d];
        handledEntryPoints.add(currentEntry.id);
        currentEntryHash = entryHashing_1.randomUint8Array(10);
        modulesVisitedForCurrentEntry = new Set(currentEntry.id);
        if (!currentEntry.manualChunkAlias) {
            addCurrentEntryColourToModule(currentEntry);
        }
    }
    for (var _e = 0, dynamicImports_1 = dynamicImports; _e < dynamicImports_1.length; _e++) {
        currentEntry = dynamicImports_1[_e];
        if (handledEntryPoints.has(currentEntry.id)) {
            continue;
        }
        handledEntryPoints.add(currentEntry.id);
        currentEntryHash = entryHashing_1.randomUint8Array(10);
        modulesVisitedForCurrentEntry = new Set(currentEntry.id);
        addCurrentEntryColourToModule(currentEntry);
    }
}
exports.assignChunkColouringHashes = assignChunkColouringHashes;
